# Contributing to Turtle

If this is your first time contributing to Turtle, please have a read through our [Code of Conduct](https://github.com/lordcodes/turtle/blob/master/CODE_OF_CONDUCT.md).

## Reporting a bug

* Compare the version you have installed against [the latest version](https://github.com/lordcodes/turtle/releases).
* Check the issue hasn't [already been reported](https://github.com/lordcodes/turtle/issues).
* Check there isn't already an [open pull request](https://github.com/lordcodes/turtle/pulls) to fix the issue.
* [Open an issue](https://github.com/lordcodes/turtle/issues/new/choose) providing as much information as possible.

## Suggesting a new feature

* Check the feature hasn't [already been requested](https://github.com/lordcodes/turtle/issues).
* [Open an issue](https://github.com/lordcodes/turtle/issues/new/choose) providing a detailed description of the new feature, why you think it is needed and how it will be useful to other users.
* If it makes sense for the feature to be added to Turtle, [a pull request](https://github.com/lordcodes/turtle/compare) adding the feature would be very much appreciated.

## Developing

If you want to make changes, please make sure to discuss anything big before putting in the effort of creating the PR.

* Clone the repository.
* Make your changes.
* Make sure all checks pass with: `./gradlew check`.
* Submit a pull request.

Thanks!
